<template>
  <tr
    role="row"
    @click="goTo(item)"
  >
    <td
      v-if="selectable"
      class="check-cell"
    >
      <div class="form-check">
        <input
          class="form-check-input-table"
          style="margin-left: -1.35em; margin-top: 0.2em;"
          type="checkbox"
          v-model="rowCheckbox"
          @click.stop="rowCheckbox = !rowCheckbox"
        >
      </div>
    </td>
    <td
      v-for="[key, value] in Object.entries(item).slice(1)"
      :key="key"
      role="cell"
      :style="
        key === 'Nombre d\'utilisateurs' ||
        key === 'Date d\'inscription' ||
        key === 'Dernière connexion' ||
        key === 'Date de création' ||
        key === 'Statut' ||
        key === 'Admin' ||
        key === 'Convention signée' ||
        key === 'Convention' ||
        key === 'Nombre d\'organisations' ||
        key === 'Date de dernière révision' ||
        key === 'Nombre d\'annexes' ||
        key === 'Accès' ||
        key === 'Niveau d\'accès'
        ? 'text-align: center' : ''
      "
    >
      <div
        v-if="key === 'Statut'"
      >
        <b-icon
          v-if="
            $route.name === 'Users' ||
            $route.name === 'OrganisationDetail' ||
            $route.name === 'GroupDetail' ||
            $route.name === 'SphereDetail'"
          icon="person-fill"
          :variant="value"
          font-scale="1.5"
        />
        <b-icon v-if="$route.name === 'Organisations'" icon="house-door-fill" :variant="value" font-scale="1.5" />
      </div>
      <div
        v-else-if="key === 'Admin' || key === 'Convention signée'"
      >
        <div v-if="value">
          <b-icon icon="check" variant="success" font-scale="1.5" />
        </div>
      </div>
      <div
        v-else-if="key === 'Convention'"
      >
        <div v-if="value">
          <b-icon
            class="convention-icon"
            style="cursor: pointer;"
            icon="file-earmark-text"
            variant="primary"
            font-scale="1.5"
            @click.stop="openConvention"
          />
        </div>
      </div>
      <div
        v-else-if="key === 'Etat'"
        style="display: flex; align-items: center; justify-content: flex-end;"
      >
        <span>{{ value }}</span>
        <b-icon-check v-if="value === 'SUCCESS'" variant="success" font-scale="2" />
        <b-icon-x v-else-if="value === 'FAILURE'" variant="danger" font-scale="2" />
        <b-icon-arrow-repeat
          v-else-if="value === 'PENDING'"
          variant="primary"
          font-scale="1.7"
          style="margin-left: 3px; margin-right: 1px;"
        />
        <b-icon-dash v-else variant="secondary" font-scale="2" />
      </div>
      <div
        v-else-if="key === 'Accès'"
      >
        <b-icon
          v-if="item['Accès'] === 0"
          icon="lock-fill"
          alt="Icône cadenas"
          :color="'#0088ff'"
          font-scale="1"
          @click.stop="$emit('access', item.id)"
        />
        <div
          v-else
          style="width: fit-content; margin: auto;"
          @click.stop="$emit('access', item.id)"
        >
          <b-icon
            style="margin-right: 0.15em;"
            icon="search"
            :color="item['Accès'] > 0 ? '#0088ff' : '#ccc'"
            font-scale="1"
          />
          <b-icon
            style="margin-right: 0.15em;"
            icon="eye-fill"
            :color="item['Accès'] > 1 ? '#0088ff' : '#ccc'"
            font-scale="1"
          />
          <b-icon
            icon="cloud-arrow-down-fill"
            :color="item['Accès'] > 2 ? '#0088ff' : '#ccc'"
            font-scale="1"
          />
        </div>
      </div>
      <div
        v-else-if="key === 'Niveau d\'accès'"
      >
        <div :id="`popover-id-${item.id}`" style="width: fit-content; margin: auto;">
          <b-icon
            style="margin-right: 0.15em;"
            icon="search"
            :color="item['Niveau d\'accès'] > 0 ? '#0088ff' : '#ccc'"
            font-scale="1.5"
          />
          <b-icon
            style="margin-right: 0.15em;"
            icon="eye-fill"
            :color="item['Niveau d\'accès'] > 1 ? '#0088ff' : '#ccc'"
            font-scale="1.5"
          />
          <b-icon
            icon="cloud-arrow-down-fill"
            :color="item['Niveau d\'accès'] > 2 ? '#0088ff' : '#ccc'"
            font-scale="1.5"
          />
        </div>
      </div>
      <div
        v-else-if="
          $route.name === 'Datasets' &&
          ['Nom', 'Organisation', 'Ressource principale'].some(el => el === key)
        "
        :id="`${item.id}-${key}-${value}`"
      >
        {{ value }}
      </div>
      <div v-else>
        {{ value }}
      </div>
      <b-popover
        v-if="
          $route.name === 'Datasets' &&
          ['Nom', 'Organisation', 'Ressource principale'].some(el => el === key)
        "
        :target="`${item.id}-${key}-${value}`"
        placement="top"
        triggers="hover"
        :content="value"
      />
    </td>
    <td
      v-if="allowDuplication"
      style="text-align: center; vertical-align: middle;">
      <b-icon
        icon="files"
        color="#0088ff"
        font-scale="1.25"
        @click.stop="duplicateDataset(item)"
      />
    </td>
    <td
      v-if="allowDeletion"
      style="text-align: center; vertical-align: middle;"
    >
      <img
        v-if="
          !(
            usersList.find(el => el.id === item.id) &&
            usersList.find(el => el.id === item.id).is_superuser === true &&
            routeTo === 'UserDetail'
          )
        "
        src="@/assets/icons/trash_delete.svg"
        alt="Icône poubelle"
        @click.stop="$emit('delete', item)"
      />
      <img
        v-else
        class="disabled"
        src="@/assets/icons/trash_delete.svg"
        alt="Icône poubelle"
      />
    </td>
  </tr>
</template>

<script>
import axios from 'axios';

import { mapState } from 'vuex';

export default {
  name: 'TableRow',

  data() {
    return {
      rowCheckbox: false
    };
  },

  props: {
    routeTo: {
      type: String,
      default: null
    },
    item: {
      type: Object,
      default: () => { return {} }
    },
    selectable: {
      type: Boolean,
      default: false
    },
    selected: {
      type: Boolean,
      default: false
    },
    allowDeletion: {
      type: Boolean,
      default: true
    },
    allowDuplication: {
      type: Boolean,
      default: false
    }
  },

  computed: {
    ...mapState('users', [
      'usersList'
    ]),
    ...mapState('datasets', [
      'selectedPermissions'
    ])
  },

  watch: {
    rowCheckbox(newValue) {
      this.$emit('select', {
        item: this.item,
        selected: newValue
      });
    },
    selectedPermissions: {
      deep: true,
      handler(newValue) {
        if (newValue.find(el => el.id === this.item.id)) {
          this.rowCheckbox = true;
        } else {
          this.rowCheckbox = false;
        }
      }
    }
  },

  created() {
    this.rowCheckbox = this.selected;
    if (this.selectedPermissions.find(el => el.id === this.item.id)) {
      this.rowCheckbox = true;
    }
  },

  methods: {
    selectRow(value) {
      this.rowCheckbox = value;
    },

    goTo(e) {
      if (this.routeTo) {
        this.$router.push({
          name: this.routeTo,
          params: { id: e.id }
        });
      }
    },

    openConvention() {
      axios.get(new URL(this.item['Convention'], process.env.VUE_APP_DOMAIN), { responseType: 'arraybuffer' })
      .then((resp) => {
        if (!resp.data) {
          return;
        }

        const buffer = Buffer.from(resp.data, 'binary');
        const mimeType = resp.headers['content-type'];
        const contentDisposition = resp.headers['content-disposition']
        let fileName;
        if (contentDisposition) {
          let matched;
          const regex = /^(attachment|inline);\sfilename="(?<fileName>[0-9a-zA-Z-_]+\.[a-zA-Z0-9]{3})"$/gm;
          while ((matched = regex.exec(contentDisposition)) !== null) {
            if (matched.index === regex.lastIndex) {
              regex.lastIndex++;
            }
            fileName = matched.groups.fileName;
          }
        } else {
          const fragment = url.split('/');
          fileName = fragment[fragment.length-1];
        }


        // https://developer.mozilla.org/en-US/docs/Web/API/Blob
        const newBlob = new Blob([buffer], { type: mimeType });

        // IE doesn't allow using a blob object directly as link href
        // instead it is necessary to use msSaveOrOpenBlob
        if (window.navigator && window.navigator.msSaveOrOpenBlob) {
          window.navigator.msSaveOrOpenBlob(newBlob);
          return;
        }

        // On crée l'objet URL à partir du Blob
        const URL = window.URL || window.webkitURL;
        const downloadUrl = URL.createObjectURL(newBlob);
        const link = document.createElement('a');
        link.download = fileName;

        // On déroule
        link.href = downloadUrl;
        document.body.append(link);
        link.click();

        // Puis on révoque
        setTimeout(() => {
          // Délai nécessaire pour révoquer l'objet
          document.body.removeChild(link);
          URL.revokeObjectURL(downloadUrl);
        }, 100);
      });
    },

    duplicateDataset(e) {
      this.$emit('duplicate', e);
    }
  }
}
//0088ff
</script>

<style lang="less" scoped>

.bi-files:hover {
  transform: scale(1.2);
}
</style>
